<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">

import { storeToRefs } from 'pinia';
import { ref, watch } from 'vue';
import { getUserAgentRegex } from 'browserslist-useragent-regexp';
import browserslist from 'browserslist';
import { notificationStatus } from '@/enums/enums';
import Progressbar from '@/components/general/Progressbar.vue';
import Modal from '@/components/general/Modal.vue';
import { useBaseStore } from '@/stores/base';
import { useFreeformStore } from '@/stores/freeform';

const store = useBaseStore();
const { status, message, modal, method, modalOKLabel } = storeToRefs(store);
const freeformStore = useFreeformStore();
const { isRnD } = storeToRefs(freeformStore);
const showUnsupportedError = ref(false);

const isUnsupportedBrowser = (): boolean => {
    const userAgent = navigator.userAgent;
    const regexp = getUserAgentRegex({
        browsers: browserslist(),
        allowHigherVersions: true
    });

    return !regexp.test(userAgent);
};

if (isUnsupportedBrowser()) {
    showUnsupportedError.value = true;
}

const handleCloseUnSupportedModal = () => {
    showUnsupportedError.value = false;
}

const getMinSupportedBrowsers = (): Record<string, string> => {
    const browsers = browserslist();
    const minVersions: Record<string, string> = {};

    browsers.forEach(browser => {
        const [name, version] = browser.split(' ');
        if (!minVersions[name] || parseFloat(version) < parseFloat(minVersions[name])) {
            minVersions[name] = version;
        }
    });

    return minVersions;
};

const minSupportedBrowser = ref(getMinSupportedBrowsers());
</script>
<template>
    <transition name="slide">
        <div class="fixed top-0 left-0 right-0 mx-auto text-white w-fit p-4 flex flex-col min-h-10 z-[9999] rounded-b-lg"
            :class="status === 'success' ? 'bg-emerald-500' : 'bg-red-500'" v-if="message.length > 0 && !modal">
            <div class="flex flex-row gap-2 text-lg">
                <div><i :class="`ri-${status === notificationStatus.DANGER ? 'error-warning' : 'check'}-line`"></i>
                </div>
                <div class="text-center w-full" v-html="message"></div>
            </div>
            <Progressbar />
        </div>
        <div v-else-if="message.length > 0 && modal">
            <Modal @submit="method" :labelSubmit="modalOKLabel" :text="message" />
        </div>
    </transition>
    <Modal :labelSubmit="$t('general.buttons.close')" @submit="handleCloseUnSupportedModal" v-if="showUnsupportedError">
        <div class="flex flex-col gap-2">
            <p>{{ $t('general.errors.unsupported.description') }}</p>
            <p>{{ $t('general.errors.unsupported.browsers.header') }}</p>
            <div>
                <b>{{ $t('general.errors.unsupported.browsers.desktop.label') }}</b>
                <ul class="list-inside list-disc text-gray-700">
                    <li>{{ $t('general.errors.unsupported.browsers.desktop.chrome.label',
                        [minSupportedBrowser['chrome']]) }} </li>
                    <li>{{ $t('general.errors.unsupported.browsers.desktop.firefox', [minSupportedBrowser['firefox']])
                        }}</li>
                    <li>{{ $t('general.errors.unsupported.browsers.desktop.edge', [minSupportedBrowser['edge']]) }}</li>
                    <li>{{ $t('general.errors.unsupported.browsers.desktop.safari', [minSupportedBrowser['safari']]) }}
                    </li>
                </ul>
            </div>
            <div>
                <b>{{ $t('general.errors.unsupported.browsers.mobile.header') }}</b>
                <ul class="list-inside list-disc text-gray-700">
                    <li>{{ $t('general.errors.unsupported.browsers.mobile.chrome_and', [minSupportedBrowser['and_chr']])
                        }} </li>
                    <li>{{ $t('general.errors.unsupported.browsers.mobile.firefox_and', [minSupportedBrowser['and_ff']])
                        }}</li>
                    <li>{{ $t('general.errors.unsupported.browsers.mobile.safari', [minSupportedBrowser['ios_saf']]) }}
                    </li>
                </ul>
            </div>
        </div>
    </Modal>
    <div class="scrollbar min-h-[100vh] p-0" style="min-height: -webkit-fill-available;">
        <router-view></router-view>
    </div>
</template>


<style scoped>
.slide-enter-active,
.slide-leave-active {
    transition: all 0.5s ease-in-out;
}

.slide-enter,
.slide-leave-to,
.slide-enter-from {
    transform: translateY(-100%);
    opacity: 0;
}

.slide-enter-to,
.slide-leave {
    transform: translateY(0);
    opacity: 1;
}
</style>